<?php
/*
    Template Name: Home Page
*/

get_header(); ?>

<div class="uk-width-1-1">
    <?php $auto = CFS()->get( 'autoplay_slider' ); ?>
    <div class="uk-slidenav-position" data-uk-slideshow="{<?php if($auto == '1') { echo "autoplay:true"; }?><?php echo ", autoplayInterval:" . CFS()->get( 'autoplay_interval' ); ?>}">
        <ul class="uk-slideshow">
            <?php $slider = CFS()->get( 'slider' ); ?>
            <?php foreach ( $slider as $slide ) : ?>
                <li>
                    <img src="<?php echo $slide['image']; ?>">
                    <div class="uk-container uk-container-center uk-overlay-panel uk-flex uk-flex-center uk-flex-middle uk-text-center">
                        <div class="pre-container"><!--style="padding:5% 5px; background:rgba(0,0,0,.4)"-->
                            <?php echo $slide['image_body']; ?>
                            <div class="slider-button"><a href="<?php echo $slide['button_link']; ?>"><?php echo $slide['button_text']; ?></a></div>
                        </div>
                    </div>
                </li>
            <?php endforeach; ?>
            
        </ul>
        <?php $nav = CFS()->get( 'show_slider_navigation' ); ?>
        <?php if($nav == '1') : ?>
        <a class="uk-slidenav uk-slidenav-contrast uk-slidenav-previous uk-hidden-medium uk-hidden-small" href="" data-uk-slideshow-item="previous"></a>
        <a class="uk-slidenav uk-slidenav-contrast uk-slidenav-next uk-hidden-medium uk-hidden-small" href="" data-uk-slideshow-item="next"></a>
        <ul class="uk-dotnav uk-dotnav-contrast uk-position-bottom uk-flex-center uk-hidden-large">
        <?php $scounter = 0; ?>
        <?php $dotnav = CFS()->get( 'slider' ); ?>
        <?php foreach ($dotnav as $dot) : ?>
           <li data-uk-slideshow-item="<?php echo $scounter; ?>"><a href=""></a></li>
           <?php $scounter++; ?>
        <?php endforeach; ?>
        </ul>
        <?php endif; ?>
    </div>
</div>


<div class="uk-width-1-1 planner-intro-container" style="background:<?php echo CFS()->get( 'introduction_banner_colour' ); ?>;">
    <div class="uk-container uk-container-center uk-text-center"><?php echo CFS()->get( 'introduction_banner_body' ); ?></div>
</div>

<?php $dpreview = CFS()->get( 'disable_preview' ); ?>
<?php if($dpreview == '0') : ?> 
<div class="uk-width-1-1 planner-preview-container">
    <div class="uk-container uk-container-center">
        <div class="uk-grid uk-grid-collapse">
            <div class="uk-width-large-1-2 uk-width-1-1">
                <img class="uk-width-1-1 preview" src="<?php echo CFS()->get( 'preview_section_image' ); ?>">
            </div>
            <div class="uk-width-large-1-2 uk-width-1-1 uk-flex uk-flex-middle">
                <div style="padding:10px 0px 10px 10px;"><?php echo CFS()->get( 'preview_section_body' ); ?></div>
            </div>
        </div>
    </div>
</div>
<?php endif; ?>

<!--<div class="uk-width-1-1 icon-set-container" style="background:<?php echo CFS()->get( 'icon_section_background_colour' ); ?>;">
    <div class="uk-container uk-container-center uk-flex uk-flex-center uk-flex-middle uk-text-center">
        <div class="uk-grid uk-width-1-1">
            <?php 
            /*$imgs = CFS()->get( 'images' );
            $counter_t = 0; 
            $counter = 0; 
            foreach($imgs as $img) { echo $counter_t; }*/
            ?>
            <?php //foreach($imgs as $img ) : ?>
                <div class="uk-width-large-1-6 uk-width-medium-1-3 uk-width-1-1 uk-flex uk-flex-middle uk-flex-center uk-text-center">
                    <img src="<?php //echo $img['image']; ?>" alt="">
                </div>
                <?php //$counter++; ?>
            <?php //endforeach; ?>
        </div>
    </div>
</div>-->

<div class="uk-width-1-1 icon-set-container" style="background:<?php echo CFS()->get( 'icon_section_background_colour' ); ?>;">
    <div class="uk-container uk-container-center uk-flex uk-flex-center uk-flex-middle uk-text-center">
        <div class="uk-grid uk-width-1-1">
            <?php $imgs = CFS()->get( 'images' ); ?>
            <?php $counter = $total = 0; ?>
            <?php foreach ($imgs as $img) { $total++; } ?>
            <?php $cal = 5 - $total; ?> 
            <?php $ncal = $cal / 2; ?>
            <?php if ($ncal == 2.5) { $ncal = 1; } ?>
            <?php if ($total != 6) : ?><div class="uk-visible-large uk-width-<?php echo $ncal; ?>-5"></div><?php endif; ?>
            <?php foreach($imgs as $img) : ?>
                <div class="uk-width-large-1-5 uk-width-medium-1-3 uk-width-1-1 uk-flex uk-flex-middle uk-flex-center uk-text-center">
                    <img src="<?php echo $img['image']; ?>" alt="">
                </div>
                <?php $counter++; ?>
            <?php endforeach; ?>
            <?php if ($total != 5) : ?><div class="uk-visible-large uk-width-<?php echo $ncal; ?>-5"></div><?php endif; ?>
        </div>
    </div>
</div>

<?php $dfeature = CFS()->get( 'disable_feature' ); ?>
<?php if($dfeature == '0') : ?>
<div class="uk-width-1-1 uk-overlay feature-1" style="max-height: 83vh; background-image: linear-gradient(rgba(0,0,0,.2),rgba(0,0,0,.2)),url(<?php echo CFS()->get( 'feature_background_image' ); ?>); background-size: cover; background-position: 50% 50%;">
    <img class="uk-width-1-1 uk-invisible" src="<?php echo CFS()->get( 'feature_background_image' ); ?>">
    <div class="uk-container uk-container-center uk-overlay-panel uk-flex uk-flex-center uk-flex-middle uk-text-center">
        <div><?php echo CFS()->get( 'feature_body_text' ); ?></div>
    </div>
</div>
<?php endif; ?>

<?php $dfeature2 = CFS()->get( 'disable_feature_2' ); ?>
<?php if($dfeature2 == '0') : ?>
<div class="uk-width-1-1">
    <div class="uk-grid uk-grid-collapse feature-2">
        <div class="uk-width-large-2-5 uk-width-1-1 uk-flex uk-flex-middle uk-flex-right" 
             style="background:<?php echo CFS()->get( 'feature_2_body_background_colour' ); ?>;">
            <div class="uk-width-large-5-6 uk-width-1-1 uk-text-right" style="margin: 0px 30px;"><?php echo CFS()->get( 'feature_2_body_text' ); ?></div>
        </div>
        <div class="uk-width-large-3-5 uk-width-1-1" style="overflow: hidden; max-height: 60vh;"><img src="<?php echo CFS()->get( 'feature_2_side_image' ); ?>"></div>
    </div>
</div>
<?php endif; ?>

<?php get_footer(); ?>