<?php

/* INCLUDES */

function tr_script_enqueue() {
    wp_enqueue_style('customstyle', get_template_directory_uri() . '/css/main.css', array(), '1.0.0', 'all');
    wp_enqueue_script('customjs', get_template_directory_uri() . '/js/main.js', array(), '1.0.0', true);

    //wp_enqueue_script('jquery', '//ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js');

    //wp_register_style( 'w3', '//www.w3schools.com/lib/w3.css' );
    //wp_enqueue_style( 'w3');
}
add_action('wp_enqueue_scripts', 'tr_script_enqueue');

function uikit_enqueue() {
	wp_register_style( 'uikitcss', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/css/uikit.min.css' );
    wp_register_style( 'uikitslideshowcss', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/css/components/slideshow.min.css' );
    wp_register_style( 'uikitslidenavcss', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/css/components/slidenav.min.css' );
    wp_register_style( 'uikitdotnavcss', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/css/components/dotnav.min.css' );
    wp_register_style( 'uikitstickycss', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/css/components/sticky.min.css');
    wp_register_style( 'uikitstickycssgrad', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/css/components/sticky.gradient.min.css' );
    wp_register_style( 'uikitstickycssflat', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/css/components/sticky.almost-flat.min.css' );
	wp_enqueue_style( 'uikitcss');
	wp_enqueue_style( 'uikitslideshowcss');
    wp_enqueue_style( 'uikitslidenavcss');
    wp_enqueue_style( 'uikitdotnavcss');
    wp_enqueue_style( 'uikitstickycss' );
    wp_enqueue_style( 'uikitstickycssgrad' );
    wp_enqueue_style( 'uikitstikcycssflat' );
    wp_enqueue_script('uikitjs', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/js/uikit.min.js');
    wp_enqueue_script('uikitmodaljs', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/js/core/modal.min.js');
    wp_enqueue_script('uikitoffcanvasjs', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/js/core/offcanvas.min.js');
    wp_enqueue_script('uikitslideshowjs', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/js/components/slideshow.min.js');
    wp_enqueue_script('uikittogglejs', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/js/core/toggle.min.js');
    wp_enqueue_script('uikitstickyjs', 'https://cdnjs.cloudflare.com/ajax/libs/uikit/2.27.2/js/components/sticky.min.js' );
}
add_action( 'wp_enqueue_scripts', 'uikit_enqueue' );

function wpb_add_google_fonts() {
	wp_enqueue_style( 'wpb-google-fonts', 'https://fonts.googleapis.com/css?family=Lato:100,300,400,700,900', false );
}

add_action( 'wp_enqueue_scripts', 'wpb_add_google_fonts' );

/* MENUS */

function tr_theme_setup() {
    add_theme_support('menus');
    register_nav_menu('menu', 'Main Menu Header Navigation');
}
add_action('init', 'tr_theme_setup');

/*** SIDEBAR ***/

function tr_widget_setup() {
    register_sidebar(array(
    'name' => 'Sidebar',
    'id' => 'sidebar-1',
    'class' => 'custom',
    'description' => 'sidebar test',
    'before_widget' => '<aside id="%1$s" class="widget %2$s uk-width-1-1">',
    'after_widget' => '</aside>',
    'before_title' => '<h4 class="widget-title">',
    'after_title' => '</h4>',
    ));
}
add_action('widgets_init','tr_widget_setup');

/*** HIDE ADMIN BAR ***/

/*add_action('after_setup_theme', 'remove_admin_bar');

function remove_admin_bar() {
    if (!current_user_can('administrator') && !is_admin()) {
      show_admin_bar(false);
    }
}*/

/*add_action('after_setup_theme', 'disable_admin_bar');
function disable_admin_bar() {
    if (current_user_can('customer')) {
        show_admin_bar(false);
    }
}*/

/*** CUSTOM LOGIN CSS ***/

/*function my_custom_login() {
    echo '<link rel="stylesheet" type="text/css" href="' . get_bloginfo('stylesheet_directory') . '/css/sky-login.css" />';
}
add_action('login_head', 'my_custom_login');*/

/*** FONT AWESOME ***/

function wmpudev_enqueue_icon_stylesheet() {
	wp_register_style( 'fontawesome', '//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css' );
    wp_register_style('faanimated', '//cdnjs.cloudflare.com/ajax/libs/font-awesome-animation/0.0.10/font-awesome-animation.min.css');
    wp_register_style('maicons', 'https://fonts.googleapis.com/icon?family=Material+Icons');
	wp_enqueue_style( 'fontawesome');
    wp_enqueue_style( 'faanimated');
    wp_enqueue_style( 'maicons');
}
add_action( 'wp_enqueue_scripts', 'wmpudev_enqueue_icon_stylesheet' );

/*** BACKEND INCLUDES ***/

//require get_template_directory() . '/inc/function-admin.php';
//require get_template_directory() . '/inc/enqueue.php';